exercise_05_21: exercise_05_21.o | .gitignore
	g++ $^ -o $@ 

exercise_05_21.ii: exercise_05_21.cpp
	g++ -E $^ -o $@

exercise_05_21.s: exercise_05_21.ii
	g++ -S $^ -o $@

exercise_05_21.o: exercise_05_21.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_05_21" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_05_21 .gitignore debug

test: exercise_05_21 
	./exercise_05_21 < test.in > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_05_21.ii exercise_05_21.s
.SECONDARY: exercise_05_21.ii exercise_05_21.s

dbg: debug/exercise_05_21 

debug/exercise_05_21: debug/exercise_05_21.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_21.o: debug/exercise_05_21.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_21.s: debug/exercise_05_21.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_21.ii: exercise_05_21.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

